package net.eciz.evosciencia.model;

import java.util.Map;

import net.eciz.evosciencia.screen.SaveDataScreen;
import net.eciz.evosciencia.util.CollisionDetector;
import net.eciz.evosciencia.values.EvoScienciaValues;

import com.badlogic.gdx.Game;
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.InputProcessor;
import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import com.badlogic.gdx.maps.tiled.TiledMapTileLayer;
import com.badlogic.gdx.math.Vector2;

public class Avatar extends Sprite implements InputProcessor, EvoScienciaValues {
	
	private Vector2 velocity = new Vector2();
	private float speed = MOVEMENT_SPEED;
	
	private TiledMapTileLayer collisionLayer;
	
	private float totalMapHeight;
	private float totalMapWidth;
	private float tileWidth;
	private float tileHeight;
	
	private CollisionDetector detector;
	
	public Avatar(Sprite sprite, TiledMapTileLayer collisionLayer) {
		super(sprite);
		this.collisionLayer = collisionLayer;
		this.totalMapHeight = collisionLayer.getHeight()*collisionLayer.getTileHeight();
		this.totalMapWidth = collisionLayer.getWidth()*collisionLayer.getTileWidth();
		this.tileHeight = collisionLayer.getTileHeight();
		this.tileWidth = collisionLayer.getTileWidth();
		
		detector = new CollisionDetector(this.tileWidth, this.tileHeight, this.totalMapWidth, this.totalMapHeight, this.collisionLayer);
	}
	
	public void moveCharacter(DPADType type) {
//		if(  == 131 ) {
//			((Game) Gdx.app.getApplicationListener()).setScreen(new SaveDataScreen());
//		} else {
			Map<String, Object> returnValues = detector.move(type, getX(), getY(), velocity);
			setX(Float.valueOf(String.valueOf(returnValues.get("x"))));
			setY(Float.valueOf(String.valueOf(returnValues.get("y").toString())));
			velocity = (Vector2) returnValues.get("velocity");
//		}
	}
	
	public void moveCharacter(int keycode) {
		if( keycode == 131 ) {
			((Game) Gdx.app.getApplicationListener()).setScreen(new SaveDataScreen());
		} else {
			Map<String, Object> returnValues = detector.move(keycode, getX(), getY(), velocity);
			setX(Float.valueOf(String.valueOf(returnValues.get("x"))));
			setY(Float.valueOf(String.valueOf(returnValues.get("y").toString())));
			velocity = (Vector2) returnValues.get("velocity");
		}
	}
	
	@Override
	public void draw(SpriteBatch spriteBatch) {
		updatePosition(Gdx.graphics.getDeltaTime());
		super.draw(spriteBatch);
	}

	private void updatePosition(float deltaTime) {
		velocity.x = speed * deltaTime;
		velocity.y = speed * deltaTime;
	}

	@Override
	public boolean keyDown(int keycode) {
//		this.moveCharacter(keycode);
		return true;
	}

	@Override
	public boolean keyUp(int keycode) {
		return true;
	}

	@Override
	public boolean keyTyped(char character) {
		return false;
	}

	@Override
	public boolean touchDown(int screenX, int screenY, int pointer, int button) {
		return false;
	}

	@Override
	public boolean touchUp(int screenX, int screenY, int pointer, int button) {
		return false;
	}

	@Override
	public boolean touchDragged(int screenX, int screenY, int pointer) {
		return false;
	}

	@Override
	public boolean mouseMoved(int screenX, int screenY) {
		return false;
	}

	@Override
	public boolean scrolled(int amount) {
		return false;
	}

}
