package net.eciz.evosciencia.screen;

import net.eciz.evosciencia.values.EvoScienciaValues;

import com.badlogic.gdx.Game;
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Screen;
import com.badlogic.gdx.graphics.GL20;
import com.badlogic.gdx.graphics.g2d.TextureAtlas;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.Stage;
import com.badlogic.gdx.scenes.scene2d.ui.Skin;
import com.badlogic.gdx.scenes.scene2d.ui.Table;
import com.badlogic.gdx.scenes.scene2d.ui.TextButton;
import com.badlogic.gdx.scenes.scene2d.utils.ClickListener;

public class SaveDataScreen implements Screen, EvoScienciaValues {
	
//	private Texture texture;
//	private SpriteBatch batch;
//	private Sprite background;
	private Stage stage;
	private Table table;
	private Table innerTable;
	private Skin skin;
	private TextureAtlas atlas;
	
	private TextButton btnBack;
	
	// Save data button
	private TextButton btnFirstData;
	private TextButton btnSecondData;
	private TextButton btnThirdData;

	@Override
	public void render(float delta) {
		Gdx.gl.glClearColor(255, 255, 255, 1);
		Gdx.gl.glClear(GL20.GL_COLOR_BUFFER_BIT);
		
//		Table.drawDebug(stage);
		
		stage.act(delta);
		stage.draw();
	}

	@Override
	public void resize(int width, int height) {

	}

	@Override
	public void show() {
		
		stage = new Stage();
		
		Gdx.input.setInputProcessor(stage);
		
		atlas = new TextureAtlas(BUTTON_PACK);
		skin = new Skin(Gdx.files.internal(JSON_BUTTON_STYLE), atlas);
		
		table = new Table(skin);
		table.setBounds(0, 0, Gdx.graphics.getWidth(), Gdx.graphics.getHeight());
		
		innerTable = new Table(skin);
		table.setBounds(0, 0, Gdx.graphics.getWidth(), Gdx.graphics.getHeight());
		
		btnBack = new TextButton("back", skin);
		btnBack.pad(10);
		
		btnBack.addListener(new ClickListener(){
			@Override
			public void clicked(InputEvent event, float x, float y) {
				((Game) Gdx.app.getApplicationListener()).setScreen(new MainMenu());
			}
		});
		
		btnFirstData = new TextButton("First Data", skin, "btnList");
		
		btnFirstData.pad(10);
		
		btnSecondData= new TextButton("Second Data", skin, "btnList");
		
		btnSecondData.pad(10);
		
		btnThirdData = new TextButton("Third Data", skin, "btnList");
		
		btnThirdData.pad(10);
		
		btnFirstData.addListener(new ClickListener(){
			@Override
			public void clicked(InputEvent event, float x, float y) {
//				btnFirstData.
				((Game) Gdx.app.getApplicationListener()).setScreen(new GameScreen());
			}
		});
		
		table.debug();
		
		innerTable.add(btnFirstData).spaceBottom(10).row();
		innerTable.add(btnSecondData).spaceBottom(10).row();
		innerTable.add(btnThirdData).spaceBottom(10).row();
		
		table.add(btnBack).left().top().expandX().row();
		table.add(innerTable).center().expandY();
		
		stage.addActor(table);
		
	}

	@Override
	public void hide() {

	}

	@Override
	public void pause() {

	}

	@Override
	public void resume() {

	}

	@Override
	public void dispose() {
		stage.dispose();
		skin.dispose();
		atlas.dispose();
	}

}
